// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef DWB_MSGS__SRV__GENERATE_TWISTS__RESPONSE__STRUCT_HPP_
#define DWB_MSGS__SRV__GENERATE_TWISTS__RESPONSE__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "nav_2d_msgs/msg/twist2_d.hpp"  // twists

#ifndef _WIN32
# define DEPRECATED_dwb_msgs_srv_GenerateTwists_Response __attribute__((deprecated))
#else
# define DEPRECATED_dwb_msgs_srv_GenerateTwists_Response __declspec(deprecated)
#endif

namespace dwb_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GenerateTwists_Response_
{
  using Type = GenerateTwists_Response_<ContainerAllocator>;

  explicit GenerateTwists_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit GenerateTwists_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _twists_type =
    std::vector<nav_2d_msgs::msg::Twist2D_<ContainerAllocator>, typename ContainerAllocator::template rebind<nav_2d_msgs::msg::Twist2D_<ContainerAllocator>>::other>;
  _twists_type twists;

  // setters for named parameter idiom
  Type * set__twists(
    const std::vector<nav_2d_msgs::msg::Twist2D_<ContainerAllocator>, typename ContainerAllocator::template rebind<nav_2d_msgs::msg::Twist2D_<ContainerAllocator>>::other> & _arg)
  {
    this->twists = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_dwb_msgs_srv_GenerateTwists_Response
    std::shared_ptr<dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_dwb_msgs_srv_GenerateTwists_Response
    std::shared_ptr<dwb_msgs::srv::GenerateTwists_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GenerateTwists_Response_ & other) const
  {
    if (this->twists != other.twists) {
      return false;
    }
    return true;
  }
  bool operator!=(const GenerateTwists_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GenerateTwists_Response_

// alias to use template instance with default allocator
using GenerateTwists_Response =
  dwb_msgs::srv::GenerateTwists_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace dwb_msgs

#endif  // DWB_MSGS__SRV__GENERATE_TWISTS__RESPONSE__STRUCT_HPP_
